from singleton import Singleton
import json
import os
from lowlevel import LowLevel


class Config(metaclass=Singleton):
    def __init__(self, cwd=None):
        self.__data = None
        self.__cwd = None
        if not self.__cwd:
            self.__cwd = os.getcwd()
        with open(os.path.join(self.__cwd, "config.json"), "r") as f:
            self.__data = json.load(f)
        pass

    def reload(self):
        if not self.__cwd:
            self.__cwd = os.getcwd()
        with open(os.path.join(self.__cwd, "config.json"), "r") as f:
            self.__data = json.load(f)
        LowLevel().init()  # reinitialize

    def get_data(self):
        return self.__data

    def get_sensors_dict(self):
        return self.__data["sensors"]

    def get_sensor_defaults(self):
        return self.__data["sensor-defaults"]

    def get_pwm_defaults(self):
        return self.__data["pwm-defaults"]

    def get_pwm_upper(self):
        return self.__data["pwm"]["upper-fan"]

    def get_pwm_lower(self):
        return self.__data["pwm"]["lower-fans"]
