from config import Config
import time
from threading import Thread
from temperature import Temperature
import graphitesend
from lowlevel import LowLevel


class Service(object):
    def __init__(self):
        self.__cfg = Config()

        pass

    def run(self):
        interval = self.__cfg.get_data()["interval"]
        t = time.time()
        last = None
        ran = False
        while True:
            t = time.time()
            if int(t) % interval == 0 and not ran:
                thread = Thread(self.work)
                thread.start()
                ran = True
                last = int(t)
            else:
                time.sleep(0.01)
                if t > last:
                    ran = False
        pass

    def work(self):
        # get sensor data
        channels = self.__cfg.get_data()["activated-channels"]
        results = []
        for c in channels:
            results.append(Temperature(c).read())

        # check thresholds
        thresholds = self.__cfg.get_data()["thresholds"]
        sensors = self.__cfg.get_sensors_dict()
        channel = -1
        for k in sensors:
            if sensors[k]["name"] == self.__cfg.get_data()["thresholds-for"]:
                channel = int(k)
        if k < 0:
            raise RuntimeError("fuck.")
#         for threshold in thresholds:
#             if results[channel] < threshold["temp"]:
#                 LowLevel().lower_fan(threshold["fan-low"])
#                 LowLevel().lower_fan_pwm(threshold["pwm-low"])
#                 LowLevel().upper_fan(threshold["fan-up"])
#                 LowLevel().upper_fan_pwm(threshold["pwm-up"])
#                 break
        pass

