

from decimal import *
from lowlevel import LowLevel
from config import Config


class Temperature(object):
    def __init__(self, channel):
        self.__channel = channel
        self.__cfg = Config()
        self.__const_resistance = self.__cfg.get_sensors_dict()[str(channel)]["pre-resistance"]
        self.__nom_temp = self.__cfg.get_sensor_defaults()["temperature_nominal"]
        self.__nom_resistance = self.__cfg.get_sensor_defaults()["resistance_nominal"]
        self.__correction = self.__cfg.get_sensor_defaults()["correction_resistance"]

    def read(self):
        ll = LowLevel()
        r = (self.__const_resistance/(4095/ll.retrieve_adc(self.__channel) - 1))
        r = r - self.__correction
        t = r/self.__nom_resistance
        if t < 0:
            t = t * -1
        t = float(Decimal(t).ln())/4050 + 1.0/(self.__nom_temp + 273.15)
        t = 1/t
        t = t - 273.15
        return t
